#include "ShrubberyCreationForm.hpp"
#include "AForm.hpp"

#include <iostream>
#include <fstream>
#include <string>

ShrubberyCreationForm::ShrubberyCreationForm():
	AForm("shrubbery creation", 137, 145, "")
{
	std::cout << "ShrubberyCreationForm()" << std::endl;
}

ShrubberyCreationForm::ShrubberyCreationForm(const std::string& target):
	AForm("ShrubberyCreationForm", 137, 145, target)
{
	std::cout << "ShrubberyCreationForm(" << target << ")" << std::endl;
}

ShrubberyCreationForm::ShrubberyCreationForm(const ShrubberyCreationForm& src):
	AForm(src)
{
	std::cout << "ShrubberyCreationForm(ShrubberyCreationForm)" << std::endl;
}

ShrubberyCreationForm::~ShrubberyCreationForm()
{
	std::cout << "~ShrubberyCreationForm()" << std::endl;
}

ShrubberyCreationForm& ShrubberyCreationForm::operator=(const ShrubberyCreationForm &src)
{
	if (this != &src)
		*this = src;
	return *this;
}

void ShrubberyCreationForm::execute(const Bureaucrat &exec) const
{
	static const std::string asciiTrees =
		"       _-_\n"
		"    /~~   ~~\\\n"
		" /~~         ~~\\\n"
		"{               }\n"
		" \\  _-     -_  /\n"
		"   ~  \\\\ //  ~\n"
		"_- -   | | _- _\n"
		"  _ -  | |   -_\n"
		"      // \\\\\n"
		"       _-_\n"
		"    /~~   ~~\\\n"
		" /~~         ~~\\\n"
		"{               }\n"
		" \\  _-     -_  /\n"
		"   ~  \\\\ //  ~\n"
		"_- -   | | _- _\n"
		"  _ -  | |   -_\n"
		"      // \\\\\n"
	;
	AForm::execute(exec);

	std::ofstream file((this->_target + "_shruberry").c_str());

	if (!file.good())
	{
		std::cout << "error: " << this->_target << "_shruberry" << "file incorrect" << std::endl;
		return;
	}
	file << asciiTrees;

}
