#include "PresidentialPardonForm.hpp"
#include "AForm.hpp"

#include <string>
#include <iostream>

PresidentialPardonForm::PresidentialPardonForm():
	AForm("PresidentialPardonForm", 5, 25, "")
{
	std::cout << "PresidentialPardonForm()" << std::endl;
}

PresidentialPardonForm::PresidentialPardonForm(const std::string& target):
	AForm("PresidentialPardonForm", 5, 25, target)
{
	std::cout << "PresidentialPardonForm(" << target << ")" << std::endl;
}

PresidentialPardonForm::PresidentialPardonForm(const PresidentialPardonForm& src):
	AForm(src)
{
	std::cout << "PresidentialPardonForm(PresidentialPardonForm)" << std::endl;
}

PresidentialPardonForm::~PresidentialPardonForm()
{
	std::cout << "PresidentialPardonForm()" << std::endl;
}

PresidentialPardonForm& PresidentialPardonForm::operator=(const PresidentialPardonForm& src)
{
	if (this != & src)
		*this = src;
	return *this;
}

void PresidentialPardonForm::execute(const Bureaucrat &exec) const
{
	AForm::execute(exec);
	std::cout << this->_target << " has been pardoned by Zaphod Beeblebrox" << std::endl;
}
